(function($) {
	$.gamesRegistry('register', 'order', new (function() {
		
		this.options = {
			'view_width':Infinity,
			'view_height':Infinity,
			'view_background_img':'',
			'cards_number':0,				
			'cards_order': []		
		};
		
		var zonePrototype = {
				'x':Infinity,
		    	'y':Infinity,
		    	'width':0,
				'height':0,
		    	'image':''
		};
		
		this.playSound=function()
		{
			if (snd_instance){
				snd_instance.stop();
				snd_instance=null;
			}
			
			if (this.options.sound_start!==undefined && this.options.sound_start!='') {

				if (SOUND_ON){
					snd_instance=createjs.Sound.play(this.options.sound_start, createjs.Sound.INTERUPT_LATE);
					
					snd_instance.addEventListener("complete", function(){
						snd_instance=null;	
						
					});	
				}
			}
		}	
		
		//=========================================================
		
		this.addActors=function()
		{
			var self=this;
			
			$('.actor').remove();
			
			if (this.options.actors===undefined) return;
			
			$.each(this.options.actors,function(index,actor){
				
			    var actor_div=$('<div class="actor" id="actor-'+index+'" style="position:absolute;"></div>');
		
			    if (actor.img!==undefined){
				    var img=preload.getResult(actor.img);
				    actor_div.css('background-image','url("' + img.src + '")');
				    
				    if (actor.width===undefined){
				    	actor.width=img.width;
				    }
				    if (actor.height===undefined){
				    	actor.height=img.height;
				    }
			    }
			    else if(actor.text!==undefined){
			    	
					if (actor.color!==undefined) {
						actor_div.css('color',actor.color);
					}
					if (actor.font!==undefined) {
						actor_div.css('font-family',actor.font);
					}
					if (actor.size!==undefined) {
						actor_div.css('font-size',actor.size);
					}
					if (actor.align!==undefined) {
						actor_div.css('text-align',actor.align);				
					}	
					
			    	actor_div.html(actor.text);
					
			    }
			    
				if (actor.hidden!==undefined && actor.hidden==true){
					actor_div.css('display','none');
				}
				
				if (actor.class_name!==undefined){
					actor_div.addClass(actor.class_name);
				}
			    
				area = new absoluteArea(actor);
				area.applyAt(actor_div, {
					view_width : self.options.view_width,
					view_height : self.options.view_height
				});		
			
				$('#playground').append(actor_div);
			
			});
		}
		
		//=========================================================
				
		this.clear = function() {
			$('#playground').sortable('destroy');
			$('.card').remove();
			$('.actor').remove();
		}

		//=========================================================
		
		this.restart = function() {
			this.randomizeCards();
			this.addActors();
			$('#playground').sortable('enable');
			$('.card').fadeIn('slow');
		}

		//=========================================================
		
		this.checkTask = function() {
			var self=this;
			var cards_div=$('.card');
			
			var ok=true;
			
			var n= this.options.cards_number-1;
			cards_div.each(function(index,card_div)
			{
				var id=$(card_div).attr('id');
				id=id.split('-');
				id=parseInt(id[1],10);	
				
				img=self.options.cards[index].img;
				card_img=$(card_div).attr('card-img');

				if (img!=card_img)	//normal
				{
					ok=false;
				}

				
				n--;
			});
			
			if (ok==true)
			{
				$('#playground').sortable('disable');
				setTimeout(function() {
					onCheckTask();					
				}, 2000);				
			}
		}	
		
		//=========================================================
		
		this.orderCard=function()
		{
			var self=this;
			
			var offsx=0;
			var offsy=0;
			var start_x=this.options.start_x;
			var start_y=this.options.start_y;
			var columns=this.options.columns;
			
			var in_column=Math.round(this.options.cards_number/columns);
			
			var children = $("#playground").children('div:visible:not(.ui-sortable-helper)');
			
			for (var i = 0; i < this.options.cards_number; i++) 
			{

				if (i==in_column)
				{
					start_x=this.options.start_x+this.options.column_offset_x+card.width;
					start_y=this.options.start_y;
				}
				
				var id=$(children[i]).attr('id');
				
				var card=null;
				$.each(self.options.cards,function(index,_card){
					
					if (_card.id==id)
						card=_card;
				});
				
				var x = start_x;
				var y = start_y-card.height;
								
			    var card_obj={
			    		width:card.width,
			    		height:card.height,
			    		x:x,
			    		y:y,
			    };
			    
				area = new absoluteArea(card_obj);
				area.applyAt(children[i], {
					view_width : this.options.view_width,
					view_height : this.options.view_height
				});	
				
				start_x+=card.width+this.options.offset_x;	
			//	start_y+=card.height+this.options.offset_y;	
			}		
		};
		
		//=========================================================
		
		this.shufleCards=function()
		{
			this.options.cards_order = this.options.cards_order.shuffle();
		};
		
		//=========================================================
		
		this.randomizeCards=function()
		{
			for(var i=0;i<this.options.cards_number;i++)
				this.options.cards_order[i]=i;
		
			this.shufleCards();

			$('#playground').empty();
			this.prepareCardContainer();
			
		};
		
		//=========================================================
		
		this.createCardDiv=function(card_id,_x,_y,img,class_name,img_name)
		{
			var width=img.width;
			var height=img.height;
			
		    var card_obj={
		    		width:width,
		    		height:height,
		    		x:_x,
		    		y:_y
		    };
	
		    if (class_name===undefined)
		    	class_name="card"
		    var card=$('<div class="'+class_name+' item" card-img="'+img_name+'" id="'+card_id+'" style="position:absolute; background-image:url(' + img.src + ');"></div>');
		    
			area = new absoluteArea(card_obj);
			area.applyAt(card, {
				view_width : this.options.view_width,
				view_height : this.options.view_height
			});
			
		    return $(card);
		};
		
		//=========================================================
		
		this.prepareCardContainer=function()
		{
			var offsx=0;
			var offsy=0;
			var start_x=this.options.start_x;
			var start_y=this.options.start_y;
			var columns=this.options.columns;
			
			var in_column=Math.round(this.options.cards_number/columns);
			
			for (var i = 0; i < this.options.cards_number; i++) 
			{
				if (i==in_column)
				{
					start_x=this.options.start_x+this.options.column_offset_x+img.width;
					start_y=this.options.start_y;
				}
				
				var j=this.options.cards_order[i];
				
				var img=preload.getResult(this.options.cards[j].img);
				
				var width=img.width;
				var height=img.height;				
				
				this.options.cards[j].width=width;
				this.options.cards[j].height=height;
				
				var x = start_x;
				var y = start_y-height;
				
				this.options.cards[j].x=x;
				this.options.cards[j].y=y;
				
				var id='card_id-'+j;
				this.options.cards[j].id=id;
				
				var card = this.createCardDiv(id, x, y,img,undefined,this.options.cards[j].img);

				$('#playground').append(card);
				
				if (this.options.cards[j].title!==undefined){
					card.attr('title',this.options.cards[j].title);
				}				
				
				start_x+=width+this.options.offset_x;	
			//	start_y+=height+this.options.offset_y;	
			}		
		};
		
		//=========================================================

		this.init = function(data) {
			
			var self = this;

			$.extend(this.options, data);
			
			$('#task-content-text').html(this.options.help);

			// Set background
			var background = preload.getResult(self.options.view_background_img).src;

			$('#playground').css('background-image','url("' + background + '")');

			setTimeout(function() {
				$('#start-page').fadeOut('slow', function() {
					$('.task-content').removeClass('hide');
				});
			}, 500);	
			
			
			this.options.cards_number=Object.keys(this.options.cards).length;
			if (this.options.cards_number==0)
			{
				alert("Brak kart");
				return;
			}			
			this.options.cards_order=new Array(this.options.cards_number);
				
			this.randomizeCards();
			
			this.addActors();
							
			$('#playground').sortable(
			{
				items:'.card',
				helper : "clone",
				tolerance: "fit",
				revert : true,
				distance : 0,
				tolerance:'pointer',
				placeholder : 'card_block_placeholder',

				change : function(e, ui) 
				{			
					self.orderCard();
				},
					
				start : function(event, ui) 
				{
					$('.card').removeClass('animated fadeIn');


					ui.helper.attr('id', null);

					var id=$(ui.item).attr('id');
					ui.placeholder.css('border','0px');
					ui.placeholder.attr('id', id);
					
					var y=parseInt($(ui.helper).css('top').replace('px',''),10);
					var x=parseInt($(ui.helper).css('left').replace('px',''),10);
								
					if (x=='0' || y=='0') return;
					
					$(ui.placeholder).css('top', y+'px');
					$(ui.placeholder).css('left',x+'px');
				},
				
				stop : function(event, ui) 
				{
					self.orderCard();
					ui.item.addClass('animated wiggle');	
					self.checkTask();
				}
			});				 
					
			
		};
				
		
	})());
	
})(jQuery);

